#! /bin/sh
# PCP QA Test No. 565
# Install/Remove for sendmail PMDA
#
# Copyright (c) 2015 Red Hat.
# Copyright (c) 1995-2002 Silicon Graphics, Inc.  All Rights Reserved.
#

seq=`basename $0`
echo "QA output created by $seq"

# get standard environment, filters and checks
. ./common.product
. ./common.filter
. ./common.check

[ -f $PCP_PMDAS_DIR/sendmail/pmdasendmail ] || _notrun "sendmail pmda not installed"

rm -f $seq.out
case $PCP_PLATFORM
in
    linux|darwin|solaris|freebsd)
	# same output for all of these platforms
	ln $seq.out.1 $seq.out || exit 1
	;;
    *)
	_notrun "Need qualified output for $PCP_PLATFORM"
	;;
esac

status=1	# failure is the default!
done_clean=false

_cleanup()
{
    if $done_clean
    then
	:
    else
	if [ -f $tmp.pmcd.conf ]
	then
	    $sudo cp $tmp.pmcd.conf $PCP_PMCDCONF_PATH
	    rm -f $tmp.pmcd.conf
	fi
	_service pmcd restart 2>&1 | _filter_pcp_restart
	_wait_for_pmcd
	_service pmlogger restart 2>&1 | _filter_pcp_restart
	_wait_for_pmlogger
	if $install_on_cleanup
	then
	    ( cd $PCP_PMDAS_DIR/sendmail; $sudo ./Install </dev/null >/dev/null 2>&1 )
	else
	    ( cd $PCP_PMDAS_DIR/sendmail; $sudo ./Remove </dev/null >/dev/null 2>&1 )
	fi
	done_clean=true
    fi
    $sudo rm -f $tmp.*
    exit $status
}

install_on_cleanup=false
pminfo sendmail >/dev/null 2>&1 && install_on_cleanup=true

trap "_cleanup" 0 1 2 3 15

_filter()
{
    sed \
	-e 's/.* \(hash table entries\)/  NNN \1/' \
	-e 's/.* \(non-leaf nodes\)/  NNN \1/' \
	-e 's/.* \(leaf nodes\)/  NNN \1/' \
	-e 's/.* \(bytes of symbol table\)/  NNN \1/' \
	-e 's/[0-9][0-9]* warnings, //' \
	-e 's/metrics and [0-9][0-9]*/metrics and N/' \
	-e '/^sendmail\..* No value(s) available/d' \
	-e "/make: Nothing to be done for .install./d" \
	-e '/^Installing .mchart view*/d' \
	-e '/Installing files \.\.\./d' \
	-e '/Removing files \.\.\./d'
}

# real QA test starts here
home=$PCP_PMDAS_DIR
iam=sendmail
if [ ! -d $home/$iam ]
then
    echo "Where is $home/$iam?"
    exit 1
fi
cd $home/$iam
unset ROOT MAKEFLAGS

# copy the pmcd config file to restore state later.
cp $PCP_PMCDCONF_PATH $tmp.pmcd.conf

# start from a known starting point
$sudo ./Remove >/dev/null 2>&1

if [ -f Makefile ] ; then
    if $sudo $PCP_MAKE_PROG clobber >$tmp.out 2>&1
    then
	:
    else
	cat $tmp.out
	echo "Arrgh, make clobber failed"
	exit
    fi

    if $sudo $PCP_MAKE_PROG >$tmp.out 2>&1
    then
	:
    else
	cat $tmp.out
	echo "Arrgh, make failed"
	exit
    fi
fi

echo
echo "=== default $iam agent installation ==="
$sudo ./Remove >$tmp.out 2>&1
$sudo ./Install </dev/null >>$tmp.out 2>&1

# cp $tmp.out $seq_full

_filter <$tmp.out

echo
echo "=== validate pmns ==="
pminfo $iam

echo
echo "=== remove $iam agent ==="
$sudo ./Remove >$tmp.out 2>&1
_filter <$tmp.out

status=0
exit
